package Drawnings;

import java.awt.*;
import java.util.Random;

import Entities.*;

public class DrawningCleaningCar extends DrawningTruck {
    public DrawningWheels drawningWheels;

    public DrawningCleaningCar(int speed, double weight, Color bodyColor, Color additionalColor, boolean tank, boolean sweepingBrush, boolean flashlight) {
        super(138,68);
        EntityTruck = new EntityCleaningCar(speed, weight, bodyColor, additionalColor, tank, sweepingBrush, flashlight);


        drawningWheels = new DrawningWheels();
        Random random = new Random();
        drawningWheels.setCountWheels(random.nextInt(1, 4));
    }

    @Override
    public void DrawTransport(Graphics g) {
        super.DrawTransport(g);
        if (EntityTruck == null || !(EntityTruck instanceof EntityCleaningCar cleaningCar) || _startPosX == null || _startPosY == null) {
            return;
        }
        Graphics2D g2d = (Graphics2D) g;
        if (cleaningCar.getTank()) {
            g2d.setColor(cleaningCar.getAdditionalColor());
            g2d.fillRect(_startPosX, _startPosY, 100, 38);
            g2d.setColor(Color.black);
            g2d.drawRect(_startPosX, _startPosY, 100, 38);
            g2d.setColor(cleaningCar.getBodyColor());
            g2d.fillRect(_startPosX, _startPosY + 20, 100, 10);
        }
        if (cleaningCar.getSweepingBrush()) {
            g2d.setColor(cleaningCar.getAdditionalColor());
            g2d.fillOval(_startPosX + 120, _startPosY + 50, 20, 20);
            g2d.setColor(cleaningCar.getBodyColor());
            g2d.fillOval(_startPosX + 125, _startPosY + 55, 10, 10);
            g2d.setColor(Color.black);
            g2d.drawOval(_startPosX + 120, _startPosY + 50, 19, 19);
            g2d.drawOval(_startPosX + 125, _startPosY + 55, 9, 9);
            g2d.drawLine(_startPosX + 122, _startPosY + 48, _startPosX + 130, _startPosY + 60);
        }
        if (cleaningCar.getFlashLight()) {
            g2d.setColor(cleaningCar.getAdditionalColor());
            g2d.fillRect(_startPosX + 108, _startPosY + 3, 5, 8);
        }
//        g2d.setColor(EntityCleaningCar.getBodyColor());
//        g2d.fillRect(_startPosX, _startPosY + 40, 122, 10);
//        g2d.fillRect(_startPosX + 102, _startPosY + 10, 20, 30);

        drawningWheels.DrawCleaningCarWheels(g, cleaningCar.getBodyColor(), cleaningCar.getAdditionalColor(), _startPosX, _startPosY);
        g2d.setColor(Color.black);
//
//        g2d.drawRect(_startPosX, _startPosY + 40, 122, 10);
//        g2d.drawRect(_startPosX + 102, _startPosY + 10, 20, 30);
//
//        g2d.fillRect(_startPosX + 112, _startPosY + 15, 10, 12);
    }
}
