package MovementStrategy;

public class MoveToCenter extends AbstractStrategy {
    @Override
    protected boolean IsTargetDestination() {
        ObjectParameters objParameters = GetObjectParameters();
        if (objParameters == null) {
            return false;
        }
        return objParameters.ObjectMiddleHorizontal() - GetStep() <= FieldWidth / 2 && objParameters.ObjectMiddleHorizontal() + GetStep() >= FieldWidth / 2
                && objParameters.ObjectMiddleVertical() - GetStep() <= FieldHeight / 2 && objParameters.ObjectMiddleVertical() + GetStep() >= FieldHeight / 2;
    }

    @Override
    protected void MoveToTarget() {
        ObjectParameters objParameters = GetObjectParameters();
        if (objParameters == null) {
            return;
        }
        int diffX = objParameters.ObjectMiddleHorizontal() - FieldWidth / 2;
        if (Math.abs(diffX) > GetStep()) {
            if (diffX > 0) {
                MoveLeft();
            } else {
                MoveRight();
            }
        }
        int diffY = objParameters.ObjectMiddleHorizontal() - FieldHeight / 2;
        if (Math.abs(diffY) > GetStep()) {
            if (diffY > 0) {
                MoveUp();
            } else {
                MoveDown();
            }
        }
    }
}
