package MovementStrategy;

import Drawnings.DirectionType;
import Drawnings.DrawningTruck;

public class MoveableTruck implements IMoveableObjects {
    private DrawningTruck _truck = null;
    public MoveableTruck(DrawningTruck drawningTruck) {
        _truck = drawningTruck;
    }
    public ObjectParameters GetObjectPosition() {
        if (_truck == null || _truck.getEntityTruck() == null) {
            return null;
        }
        return new ObjectParameters(_truck.GetPosX(), _truck.GetPosY(), _truck.GetWidth(), _truck.GetHeight());
    }

    public int GetStep() {return (int)(_truck.getEntityTruck().Step());}

    public boolean TryMoveObject(MovementDirection direction) {
        if (_truck == null || _truck.getEntityTruck() == null) {
            return false;
        }
        return _truck.MoveTransport(GetDirectionType(direction));
    }

    private static DirectionType GetDirectionType(MovementDirection direction) {
        switch (direction) {
            case MovementDirection.Up -> {return DirectionType.Up;}
            case MovementDirection.Right -> {return DirectionType.Right;}
            case MovementDirection.Down -> {return DirectionType.Down;}
            case MovementDirection.Left -> {return DirectionType.Left;}
            default -> {
                return DirectionType.Unknown;
            }
        }
    }
}
